<?php

namespace itguild\forms\traits;

use itguild\forms\debug\Debug;

trait CreateOption
{
    /**
     * @param array $options
     * @param $value
     * @return string
     */
//    public function createOption(array $options, $value = null): string
//    {
//        $optionsString = "";
//        if (is_array($value)) {
//            foreach ($options as $val => $title) {
//                $selected = in_array($title, $value) ? "selected" : "";
//                $optionsString .= "<option $selected value='$val'>$title</option>";
//            }
//        } else {
//            foreach ($options as $val => $title) {
//                if (is_numeric($value)) {
//                    $selected = (int)$value === $val ? "selected" : "";
//                } else {
//                    $selected = $value === $val ? "selected" : "";
//                }
//                $optionsString .= "<option $selected value='$val'>$title</option>";
//            }
//        }
//
//        return $optionsString;
//    }

    public function createOption(array $options, $value = null): string
    {
        $optionsString = "";
        if ($value) {
            if (isset($options['prompt'])) {
                $prompt = $options['prompt'];
                $optionsString .= "<option value='''>$prompt</option>";
            }

            if (is_array($value)) {
                foreach ($options as $val => $title) {
                    if ($val === 'prompt') continue;
                    $selected = in_array($title, $value) ? "selected" : "";
                    $optionsString .= "<option $selected value='$val'>$title</option>";
                }
            } else {
                foreach ($options as $val => $title) {
                    if ($val === 'prompt') continue;
                    if (is_numeric($value)) {
                        $selected = (int)$value === $val ? "selected" : "";
                    } else {
                        $selected = $value === $val ? "selected" : "";
                    }
                    $optionsString .= "<option $selected value='$val'>$title</option>";
                }
            }
        } else {
            if (isset($options['prompt'])) {
                $prompt = $options['prompt'];
                $optionsString .= "<option value='' selected='selected'>$prompt</option>";
            }
            foreach ($options as $val => $title) {
                if ($val === 'prompt') continue;
                $optionsString .= "<option value='$val'>$title</option>";
            }
        }

        return $optionsString;
    }
}